import 'package:b2b_graphql_package/GraphQLConfiguration.dart';
import 'package:graphql_flutter/graphql_flutter.dart';
import 'user_model.dart';

class UserRepo {
  var graphQLConfiguration;

  var userDetails;
  UserRepo() {
    graphQLConfiguration = GraphQLConfiguration();
  }
  // Future<bool> addUser(UserModel userModel) async {
  //   String addUserGql =
  //       """mutation addUser( \$sdgsdg: String,\$lastName: String,\$mobileNumber: Float,
  //       \$email: String,\$pwd: String) {
  //                       addUser(userInput:{firstName: \$sdgsdg,
  //                 lastName: \$lastName,
  //                 mobileNumber:\$mobileNumber,
  //                 email:\$email,
  //                 pwd:\$pwd})
  //                               {
  //                                 id
  //                               }
  //                   }""";
  //   GraphQLConfiguration graphQLConfiguration = GraphQLConfiguration();
  //   GraphQLClient _client = graphQLConfiguration.clientToQuery();
  //   final vble = {
  //     "sdgsdg": userModel.firstName,
  //     "lastName": userModel.lastName
  //   };
  //   QueryResult result = await _client.mutate(
  //     MutationOptions(
  //       document: gql(addUserGql),
  //       variables: vble,
  //     ),
  //   );
  //   if (!result.hasException) {
  //     return true;
  //   }
  //   return false;
  // }

  Future getUserById(String id) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();

    var getUserByIdGql = """ 
                query getByUserId(\$id: String) {
                getByUserId(id: \$id) {
                  _id
                  contactName
                  companyName
                  mobileNumber
                  emailId
                  altMobileNumber
                  __typename
                }
              }

            """;

    final vble = {
      "id": id,
    };
    QueryResult result = await _client.query(QueryOptions(
      document: gql(getUserByIdGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));

    if (!result.hasException) {
      var userDetailsModel = result.data!['getByUserId'];

      if (userDetailsModel != null && userDetailsModel.length > 0) {
        userDetails = userByIdFromJson(userDetailsModel);
        return userDetails;
      }
    }
    return userDetails;
  }
}
